<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCoverageLimitType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfCoverageLimitType extends AbstractStructArrayBase
{
    /**
     * The CoverageRequirement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgCoverageLimitType[]
     */
    public $CoverageRequirement;
    /**
     * Constructor method for ArrayOfCoverageLimitType
     * @uses DgArrayOfCoverageLimitType::setCoverageRequirement()
     * @param \dgsoft\StructType\DgCoverageLimitType[] $coverageRequirement
     */
    public function __construct(array $coverageRequirement = array())
    {
        $this
            ->setCoverageRequirement($coverageRequirement);
    }
    /**
     * Get CoverageRequirement value
     * @return \dgsoft\StructType\DgCoverageLimitType[]|null
     */
    public function getCoverageRequirement()
    {
        return $this->CoverageRequirement;
    }
    /**
     * Set CoverageRequirement value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgCoverageLimitType[] $coverageRequirement
     * @return \dgsoft\ArrayType\DgArrayOfCoverageLimitType
     */
    public function setCoverageRequirement(array $coverageRequirement = array())
    {
        foreach ($coverageRequirement as $arrayOfCoverageLimitTypeCoverageRequirementItem) {
            // validation for constraint: itemType
            if (!$arrayOfCoverageLimitTypeCoverageRequirementItem instanceof \dgsoft\StructType\DgCoverageLimitType) {
                throw new \InvalidArgumentException(sprintf('The CoverageRequirement property can only contain items of \dgsoft\StructType\DgCoverageLimitType, "%s" given', is_object($arrayOfCoverageLimitTypeCoverageRequirementItem) ? get_class($arrayOfCoverageLimitTypeCoverageRequirementItem) : gettype($arrayOfCoverageLimitTypeCoverageRequirementItem)), __LINE__);
            }
        }
        $this->CoverageRequirement = $coverageRequirement;
        return $this;
    }
    /**
     * Add item to CoverageRequirement value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgCoverageLimitType $item
     * @return \dgsoft\ArrayType\DgArrayOfCoverageLimitType
     */
    public function addToCoverageRequirement(\dgsoft\StructType\DgCoverageLimitType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgCoverageLimitType) {
            throw new \InvalidArgumentException(sprintf('The CoverageRequirement property can only contain items of \dgsoft\StructType\DgCoverageLimitType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CoverageRequirement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgCoverageLimitType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgCoverageLimitType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgCoverageLimitType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgCoverageLimitType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgCoverageLimitType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CoverageRequirement
     */
    public function getAttributeName()
    {
        return 'CoverageRequirement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfCoverageLimitType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
